* [------ asmhsamp.jcl  File Begin here -----	







//* Sample JCL to assemble the assembly program
//USERNAMEH JOB '(4X8AB,60000)','VTAM INTERFACE ASM',NOTIFY=USERNAME,   00001000
//         MSGLEVEL=(1,1),MSGCLASS=X                                    00002000
//ASMH     EXEC  PGM=IEV90,REGION=512K,                                 00317000
//         PARM='OBJECT,LIST,XREF,TERM'                                 00317100
//STEPLIB  DD DSN=SYS1.TPO.PPLIB,DISP=SHR                               00317200
//SYSLIB   DD DSN=SYS1.MACLIB,DISP=SHR                                  00317300
//         DD DSN=SYS4.MACLIB,DISP=SHR                                  00317500
//SYSUT1   DD UNIT=(VIO,SEP=SYSLIB),SPACE=(CYL,(10,5)),DSN=&SYSUT1,     00317700
//         DCB=BUFNO=1                                                  00317800
//SYSPUNCH DD DUMMY                                                     00317900
//SYSPRINT DD SYSOUT=*                                                  00318000
//SYSTERM  DD SYSOUT=*                                                  00318100
//*               replace               vtamrc
//SYSLIN   DD DSN=USERNAME.VTAMSAMP.OBJ(VTAMRC),DISP=SHR                00318200
//SYSIN    DD DSN=USERNAME.SIEAPI.TCDVTAM(VTAMRC),DISP=SHR              00319000
* [------ vtaminit.asm  File Begin here ]	







**************************************************************          00000100
* VTAMINIT CSECT FOR 'C' INTERFACE                                      00000200
**************************************************************          00000300
*                                                                       00000400
* VTAMINIT RECEIVES 3 PARAMETERS                                        00000500
*                                                                       00000600
*        VTAM APPL NAME ADDR                                            00000700
*        PARTNER LU NAME ADDR                                           00000800
*        MODE NAME ADDR                                                 00000900
*                                                                       00001000
* THIS ROUTINE OPENS THE VTAM ACB AND ISSUES CNOS FOR THE PARTNER LU    00001100
*                                                                       00001200
* RETURN VALUE IN R15                                                   00001300
*        0 = SUCCESS                                                    00001400
*    OTHER = NON-SUCCESSFUL                                             00001500
*                                                                       00001600
**************************************************************          00001700
R0  EQU 0                                                               00001800
R1  EQU 1                                                               00001900
R2  EQU 2                                                               00002000
R3  EQU 3                                                               00002100
R4  EQU 4                                                               00002200
R5  EQU 5                                                               00002300
R6  EQU 6                                                               00002400
R7  EQU 7                                                               00002500
R8  EQU 8                                                               00002600
R9  EQU 9                                                               00002700
R10 EQU 10                                                              00002800
R11 EQU 11                                                              00002900
R12 EQU 12                                                              00003000
R13 EQU 13                                                              00003100
R14 EQU 14                                                              00003200
R15 EQU 15                                                              00003300
*                                                                       00003400
VTAMINIT EDCPROL            C TO ASSEMBLER PROLOGUE                     00003500
         BALR  R3,R0                                                    00003600
         USING *,R3                                                     00003700
*                                                                       00003800
* GET PARAMETERS                                                        00003900
*                                                                       00004000
         L     R4,0(R1)       GET APPL NAME ADDRESS                     00004100
         L     R5,4(R1)       GET PARTNER LU                            00004200
         L     R6,8(R1)       GET MODENAME                              00004300
*                                                                       00004400
         CALL  VTINIT,((4),RC)                                          00004500
*                                                                       00004600
         L     R15,RCPRI      CHECK VTAM PRIMARY RC FOR OPEN ACB        00004700
         LTR   R15,R15                                                  00004800
         BNZ   INITX                                                    00004900
*                                                                       00005000
* ESTABLISH SESSION WITH CNOS                                           00005100
*                                                                       00005200
         LA    R7,CNOSCB                                                00005300
         USING ISTSLCNS,R7                                              00005400
         MVC   SLCSESSL,=X'0001'                                        00005500
         MVC   SLCMCWL,=X'0000'                                         00005600
         MVC   SLCMCWP,=X'0000'                                         00005700
         MVI   SLCPARMS,SLCSSLU SET SINGLE SESSION INDICATOR            00005800
         DROP  R7                                                       00005900
*                                                                       00006000
*        CALL  PRINTF,(MSG2),VL                                         00006100
         CALL  VTCNOS,((5),(6),CNOSCB,RC)                               00006200
*                                                                       00006300
         LH    R15,RCLU6PRI   ONLY CHECK LU62 PRIMARY RC FOR CNOS       00006400
*                                                                       00006500
* RESTORE REGISTERS AND RETURN                                          00006600
*                                                                       00006700
INITX    EDCEPIL                                                        00006800
*                                                                       00006900
*  RETURN CODE STRUCTURE (1 DOUBLE WORD)                                00007000
*                                                                       00007100
RC       DS   0D                                                        00007200
RCPRI    DS   0F                                                        00007300
RCAPPL   DS   H                                                         00007400
RCVMAJRC DS   CL1                                                       00007500
RCVFDBK2 DS   CL1                                                       00007600
RCLU62   DS   0F                                                        00007700
RCLU6PRI DS   H                                                         00007800
RCLU6SEC DS   H                                                         00007900
*                                                                       00008000
*  CNOS CONTROL BLOCK AREA                                              00008100
*                                                                       00008200
CNOSCB   DS    CL7                                                      00008300
*                                                                       00008400
*************** DISPLAY MESSAGES *****************************          00008500
*                                                                       00008600
* DISPLAY CONTROL BLOCKS FOR VDISP DISPLAY CALLS                        00008700
*                                                                       00008800
MSG2     DC    CL24'CALLING APPCCMD FOR CNOS'                           00008900
         DC    XL1'0D'                                                  00009000
         DC    XL1'00'                                                  00009100
*                                                                       00009200
         LTORG                                                          00009300
         DROP  R3                                                       00009400
*                                                                       00009500
*  DSECTS                                                               00009600
*                                                                       00009700
         IFGACB AM=VTAM                                                 00009800
         IFGRPL AM=VTAM                                                 00009900
         ISTFM5                                                         00010000
         ISTSLCNS                                                       00010100
         END                                                            00010200
* [------ vtamqmgr.asm  File Begin here ]	







**************************************************************          00000100
* VTAMQMGR - CSECTS FOR MAINTAINING THE CONTROL BLOCKS                  00000200
*            ACB                                                        00000300
*            RPL                                                        00000400
*            RPLX                                                       00000500
**************************************************************          00000600
* THERE IS ONE STATICALLY DEFINED SET OF CONTROL BLOCKS.                00000700
* THESE CONTROL BLOCKS ARE DEFINED IN THE VTDATA CSECT.                 00000800
*                                                                       00000900
* THERE ARE TWO ACB CSECT FUNCTIONS:                                    00001000
*                                                                       00001100
*            OPENACB                                                    00001200
*            CLOSEACB                                                   00001300
*                                                                       00001400
* THE RPL QUEUE FUNCTION IS:                                            00001500
*                                                                       00001600
*            GETRPL                                                     00001700
*                                                                       00001800
* IT PASSES BACK THE ADDRESS OF THE RPL                                 00001900
**************************************************************          00002000
*                                                                       00002100
R0  EQU 0                                                               00002200
R1  EQU 1                                                               00002300
R2  EQU 2                                                               00002400
R3  EQU 3                                                               00002500
R4  EQU 4                                                               00002600
R5  EQU 5                                                               00002700
R6  EQU 6                                                               00002800
R7  EQU 7                                                               00002900
R8  EQU 8                                                               00003000
R9  EQU 9                                                               00003100
R10 EQU 10                                                              00003200
R11 EQU 11                                                              00003300
R12 EQU 12                                                              00003400
R13 EQU 13                                                              00003500
R14 EQU 14                                                              00003600
R15 EQU 15                                                              00003700
*                                                                       00003800
**************************************************************          00003900
OPENACB  CSECT                                                          00004000
**************************************************************          00004100
*                                                                       00004200
* OPENACB:                                                              00004300
*                                                                       00004400
* THIS CSECT OPENS THE ACB.                                             00004500
*                                                                       00004600
* REGISTERS AT ENTRY:                                                   00004700
*    R13 = HSA                                                          00004800
*    R14 = RETURN ADDRESS                                               00004900
*    R15 = ENTRY ADDRESS                                                00005000
*    R1  = POINTER TO ADDRESS LIST                                      00005100
*          PARM1 = LUNAME DEFINED BY APPL STATEMENT                     00005200
*                                                                       00005300
*  RETURN VALUES:                                                       00005400
*   R15:  VTAM RETURN CODE FROM OPEN ACB MACRO                          00005500
*                                                                       00005600
**************************************************************          00005700
*                                                                       00005800
*        ESTABLISH ADDRESSABILITY AND SETUP SAVEAREA LINK               00005900
*                                                                       00006000
         USING *,R3                                                     00006100
         STM   R14,R12,12(R13)                                          00006200
         LR    R3,R15                                                   00006300
         LA    R11,OPENSV                                               00006400
         ST    R11,8(R13)                                               00006500
         ST    R13,4(R11)                                               00006600
         LR    R13,R11                                                  00006700
*                                                                       00006800
* GET THE PARAMETERS                                                    00006900
*                                                                       00007000
         L     R4,0(R1)       GET THE LUNAME ADDR                       00007100
*                                                                       00007200
* MOVE THE LUNAME INTO APPLID OF ACB                                    00007300
*                                                                       00007400
         L     R5,=A(APPLNAME)                                          00007500
         MVI   0(R5),X'08'    SET APPLNAME TO 8 BYTES                   00007600
         MVC   1(8,R5),0(R4)  MOVE IN THE LUNAME                        00007700
         OPEN  ACB            RC RETURNED IN R15                        00007800
         LTR   R15,R15                                                  00007900
         BZ    OPENX                                                    00008000
         BAL   R12,OPENERR                                              00008100
*                                                                       00008200
*        RESTORE REGISTERS AND EXIT PROGRAM                             00008300
*                                                                       00008400
OPENX    L     R13,4(R13)                                               00008500
         L     R14,12(R13)    RESTORE R14                               00008600
         LM    R1,R12,24(R13) RETURN R0,R15                             00008700
         BR    R14                                                      00008800
OPENSV   DS    18F                                                      00008900
*                                                                       00009000
**************************************************************          00009100
*  OPEN ACB ERROR ROUTINE - DISPLAY ERROR CODES AND RETURN              00009200
**************************************************************          00009300
OPENERR  ST    R15,OPERRCD    SAVE THE ERROR RETURN CODE                00009400
         ST    R12,OPERRRET   SAVE RETURN ADDR                          00009500
*                                                                       00009600
         LR    R0,R15                                                   00009700
*        CALL  XDISP,(OPMSG1)                                           00009800
*                                                                       00009900
*        CALL  VDISP,(LUBLK1,LUMSG1,LUBLK2,(4)),VL                      00010000
*                                                                       00010100
         L     R15,OPERRCD    RESTORE R15 ERROR CODE FOR TESTS          00010200
*                                                                       00010300
         C     R15,=F'4'                                                00010400
         BNE   OPER2                                                    00010500
*        WTO   'VTAM RC = 4 - WARNING MESSAGES ISSUED'                  00010600
         B     OPER4                                                    00010700
OPER2    C     R15,=F'8'                                                00010800
         BNE   OPER3                                                    00010900
*        WTO   'VTAM ACB NOT OPENED SUCCESSFULLY - RC = 8'              00011000
         B     OPER4                                                    00011100
OPER3    C     R15,=F'12'                                               00011200
         BNE   OPER4                                                    00011300
*        WTO   'VTAM ACB NOT OPENED SUCCESSFULLY - RC = 0C'             00011400
OPER4    EQU   *                                                        00011500
         L     R5,=A(ACB)                                               00011600
         USING IFGACB,R5                                                00011700
*                                                                       00011800
         XR    R0,R0                                                    00011900
         IC    R0,ACBERFLG                                              00012000
         DROP  R5                                                       00012100
*                                                                       00012200
*        CALL  XDISP,(OPMSG2)                                           00012300
*                                                                       00000000
* RESTORE REGS AND EXIT ERROR ROUTINE                                   00012500
*                                                                       00012600
         L     R15,OPERRCD    RESTORE ERR CODE FOR MAINLINE             00012700
         L     R12,OPERRRET                                             00012800
         BR    R12                                                      00012900
*                                                                       00013000
*        OPEN ERROR WORK AREAS                                          00013100
*                                                                       00013200
OPMSG1   DC    CL34'RETURN FROM VTAM OPEN ACB, R15 = '                  00013300
         DC    XL1'00'                                                  00013400
OPMSG2   DC    CL39'RETURN FROM VTAM OPEN ACB, ACBERFLG = '             00013500
         DC    XL1'00'                                                  00013600
*                                                                       00013700
LUBLK1   DC    XL1'0'         FORMAT DISPLAY TYPE = CHAR                00013800
         DC    XL1'0'         STRING IS NULL TERMINATED                 00013900
         DC    H'0'           NO LENGTH                                 00014000
LUMSG1   DC    CL31'VTAM TRYING TO OPEN APPLNAME = '                    00014100
         DC    XL1'00'                                                  00014200
*                                                                       00014300
LUBLK2   DC    XL1'0'         FORMAT DISPLAY TYPE = CHAR                00014400
         DC    XL1'1'         STRING IS LENGTH SPECIFIED                00014500
         DC    H'8'           8 BYTES                                   00014600
OPERRCD  DS    F                                                        00014700
OPERRRET DS    F                                                        00014800
         LTORG                                                          00014900
         DROP  R3                                                       00015000
*                                                                       00015100
**************************************************************          00015200
CLOSEACB CSECT                                                          00015300
**************************************************************          00015400
*                                                                       00015500
* CLOSEACB:                                                             00015600
*                                                                       00015700
* THIS CSECT CLOSES THE ACB.                                            00015800
*                                                                       00015900
* REGISTERS AT ENTRY:                                                   00016000
*    R13 = HSA                                                          00016100
*    R14 = RETURN ADDRESS                                               00016200
*    R15 = ENTRY ADDRESS                                                00016300
*                                                                       00016400
*  RETURN VALUES:                                                       00016500
*    R15 = VTAM RETURN CODE FROM CLOSE ACB MACRO                        00016600
*                                                                       00016700
**************************************************************          00016800
*                                                                       00016900
*        ESTABLISH ADDRESSABILITY AND SETUP SAVEAREA LINK               00017000
*                                                                       00017100
         USING *,R3                                                     00017200
         STM   R14,R12,12(R13)                                          00017300
         LR    R3,R15                                                   00017400
         LA    R11,CLOSESV                                              00017500
         ST    R11,8(R13)                                               00017600
         ST    R13,4(R11)                                               00017700
         LR    R13,R11                                                  00017800
*                                                                       00017900
         CLOSE ACB            RC RETURNED IN R15                        00018000
*                                                                       00018100
*        RESTORE REGISTERS AND EXIT PROGRAM                             00018200
*                                                                       00018300
         L     R13,4(R13)                                               00018400
         L     R14,12(R13)    RESTORE R14                               00018500
         LM    R1,R12,24(R13) RETURN R0,R1,R15                          00018600
         BR    R14                                                      00018700
CLOSESV  DS    18F                                                      00018800
         LTORG                                                          00018900
         DROP  R3                                                       00019000
*                                                                       00019100
**************************************************************          00019200
GETRPL   CSECT                                                          00019300
**************************************************************          00019400
*                                                                       00019500
* GETRPL:                                                               00019600
*                                                                       00019700
* THIS CSECT FINDS THE RPL CORRESPONDING TO A PASSED CONVERSATION ID    00019800
*                                                                       00019900
* REGISTERS AT ENTRY:                                                   00020000
*    R13 = HSA                                                          00020100
*    R14 = RETURN ADDRESS                                               00020200
*    R15 = ENTRY ADDRESS                                                00020300
*    R1  = POINTER TO ADDRESS LIST                                      00020400
*          PARM1 = CONVERSATION ID                                      00020500
*                                                                       00020600
*  RETURN VALUES:                                                       00020700
*    SUCCESSFUL:                                                        00020800
*       R15 = 0                                                         00020900
*       R0  = RPL ADDRESS                                               00021000
*                                                                       00021500
**************************************************************          00021600
*                                                                       00021700
*        ESTABLISH ADDRESSABILITY AND SETUP SAVEAREA LINK               00021800
*                                                                       00021900
         USING *,R3                                                     00022000
         STM   R14,R12,12(R13)                                          00022100
         LR    R3,R15                                                   00022200
         LA    R11,GETRPLSV                                             00022300
         ST    R11,8(R13)                                               00022400
         ST    R13,4(R11)                                               00022500
         LR    R13,R11                                                  00022600
*                                                                       00022700
* GET THE PARAMETERS                                                    00022800
*                                                                       00022900
         L     R4,0(R1)       GET THE CONVID ADDR AND                   00023000
         L     R5,0(R4)       PICK UP THE VALUE                         00023100
*                                                                       00023200
* THIS ROUTINE RETURNS STATIC RPL ADDR                                  00023300
*                                                                       00023400
         L     R0,=A(RPL)                                               00023500
         XR    R15,R15                                                  00023600
*                                                                       00023700
*        RESTORE REGISTERS AND EXIT PROGRAM                             00023800
*                                                                       00023900
         L     R13,4(R13)                                               00024000
         L     R14,12(R13)    RESTORE R14                               00024100
         LM    R1,R12,24(R13) RETURN R0,R1,R15                          00024200
         BR    R14                                                      00024300
GETRPLSV DS    18F                                                      00024400
         LTORG                                                          00024500
         DROP  R3                                                       00024600
*                                                                       00024700
**************************************************************          00024800
RPLDATA  CSECT                                                          00024900
**************************************************************          00025000
*    THIS CSECT CONTAINS THE GLOBAL DATA AREAS                          00025100
**************************************************************          00025200
*                                                                       00025300
         USING *,R3                                                     00025400
ACB      ACB   AM=VTAM,                                                X00025500
               APPLID=APPLNAME,                                        X00025600
               MACRF=LOGON                                              00025700
APPLNAME DC    XL1'8'                                                   00025800
         DC    CL8' '         SUPPLIED BY OPEN CSECT                    00025900
*                                                                       00026000
RPL      RPL   AM=VTAM,ACB=ACB,OPTCD=SYN,AAREA=RPLX                     00026100
RPLX     ISTRPL6                                                        00026200
         DROP  R3                                                       00026300
**************************************************************          00026400
*                                                                       00026500
* DSECTS                                                                00026600
*                                                                       00026700
         IFGACB AM=VTAM                                                 00026800
         END                                                            00026900
* [------ vtamrc.asm  File Begin here ]	







**************************************************************          00000100
* VTAMRC - 2 CSECTS:                                                    00000200
*    RCCHECK - CHECKS RETURN VALUE FROM APPCCMD REQUESTS                00000300
*    RCDISP  - DISPLAYS RETURN VALUES FROM APPCCMD REQUESTS             00000400
**************************************************************          00000500
*                                                                       00000600
R0  EQU 0                                                               00000700
R1  EQU 1                                                               00000800
R2  EQU 2                                                               00000900
R3  EQU 3                                                               00001000
R4  EQU 4                                                               00001100
R5  EQU 5                                                               00001200
R6  EQU 6                                                               00001300
R7  EQU 7                                                               00001400
R8  EQU 8                                                               00001500
R9  EQU 9                                                               00001600
R10 EQU 10                                                              00001700
R11 EQU 11                                                              00001800
R12 EQU 12                                                              00001900
R13 EQU 13                                                              00002000
R14 EQU 14                                                              00002100
R15 EQU 15                                                              00002200
*                                                                       00002300
**************************************************************          00002400
RCCHECK CSECT                                                           00002500
**************************************************************          00002600
*                                                                       00002700
* REGISTERS AT ENTRY TO ROUTINE:                                        00002800
*  R13 = HSA                                                            00002900
*  R14 = RETURN ADDRESS                                                 00003000
*  R15 = ENTRY POINT ADDRESS                                            00003100
*  R1  = PARAMETER LIST ADDRESS                                         00003200
*        PARM1 = RPL ADDRESS                                            00003300
*                                                                       00003400
* RETURN REGISTERS:                                                     00003500
*  R15 = VTAM PRIMARY/SECONDARY RETURN CODES                            00003600
*  R0  = LU6.2 PRIMARY/SECONDARY RETURN CODES                           00003700
*                                                                       00003800
*  R15 = 0000XXYY                                                       00003900
*        XX = VTAM MAJOR RETURN CODE                                    00004000
*        YY = VTAM FEEDBACK 2 RETURN CODE                               00004100
*                                                                       00004200
*  R0  = XXXXYYYY                                                       00004300
*        XXXX = LU62 PRIMARY RC                                         00004400
*        YYYY = LU62 SECONDARY RC                                       00004500
*                                                                       00004600
**************************************************************          00004700
* SAVE REGS AND ESTABLISH ADDRESSABILITY                                00004800
         USING *,R3                                                     00004900
         STM   R14,R12,12(R13)                                          00005000
         LR    R3,R15                                                   00005100
* REGISTER SAVE LINKAGE                                                 00005200
         LA    R4,RCCSAVE                                               00005300
         ST    R4,8(R13)                                                00005400
         ST    R13,4(R4)                                                00005500
         LR    R13,R4                                                   00005600
*                                                                       00005700
* GET PARAMETERS                                                        00005800
*                                                                       00005900
         L     R4,0(R1)       GET RPL ADDRESS                           00006000
         USING IFGRPL,R4                                                00006100
         L     R5,RPLAAREA                                              00006200
         USING ISTRPL6X,R5                                              00006300
*                                                                       00006400
* CHECK THE RETURN CODES                                                00006500
*                                                                       00006600
         XR    R0,R0          CLEAR LU6.2 RC                            00006700
         XR    R11,R11        TEMP BUILD MAJOR VTAM RC IN R11           00006800
*                                                                       00006900
         IC    R11,RPLRTNCD                                             00007000
         SLL   R11,8          SHIFT LEFT 1 BYTE                         00007100
         IC    R11,RPLFDBK2                                             00007200
         CH    R11,=XL2'0000' CHECK MAJOR RC/FEEDBACK                   00007300
         BE    RCC1           OK - CONTINUE                             00007400
         CH    R11,=XL2'000B' CHECK MAJOR RC/FEEDBACK                   00007500
         BE    RCC1           OK - CONTINUE                             00007600
*                                                                       00007700
         CALL  RCDISP,((4))                                             00007800
         B     RCCX           AND EXIT ROUTINE                          00007900
*                                                                       00008000
* RETURN THE LU62 PRIMARY/SECONDARY CODES IN R0                         00008100
*                                                                       00008200
RCC1     LH    R12,RPL6RCPR                                             00008300
         SLL   R12,16         SHIFT LEFT 2 BYTES                        00008400
         LH    R0,RPL6RCSC    PROPAGATE HIGH-ORDER BIT                  00008500
         OR    R0,R12         COMBINE PRIMARY/SECONDARY                 00008600
*                                                                       00008700
         DROP  R4                                                       00008800
         DROP  R5                                                       00008900
*                                                                       00009000
* RESTORE REGISTERS AND RETURN                                          00009100
*                                                                       00009200
RCCX     LR    R15,R11        R15 = VTAM RC                             00009300
         L     R13,4(R13)                                               00009400
         L     R14,12(R13)                                              00009500
         LM    R1,R12,24(R13) RC  = R15, R0                             00009600
         BR    R14                                                      00009700
RCCSAVE  DS    18F                                                      00009800
         LTORG                                                          00009900
         DROP  R3                                                       00010000
*                                                                       00010100
**************************************************************          00010200
* RCDISP  CSECT                                                         00010300
**************************************************************          00010400
*                                                                       00010500
* REGISTERS AT ENTRY TO ROUTINE:                                        00010600
*  R13 = HSA                                                            00010700
*  R14 = RETURN ADDRESS                                                 00010800
*  R15 = ENTRY POINT ADDRESS                                            00010900
*  R1  = PARAMETER LIST ADDRESS                                         00011000
*        PARM1 = RPL ADDRESS                                            00011100
*                                                                       00011200
**************************************************************          00011300
* SAVE REGS AND ESTABLISH ADDRESSABILITY                                00011400
RCDISP   EDCPROL                                                        00011500
         BALR  R3,R0                                                    00011600
         USING *,R3                                                     00011700
*                                                                       00011800
* GET PARAMETERS                                                        00011900
*                                                                       00012000
         L     R4,0(R1)       GET RPL ADDRESS                           00012100
         USING IFGRPL,R4                                                00012200
         L     R5,RPLAAREA                                              00012300
         USING ISTRPL6X,R5                                              00012400
*                                                                       00012500
         XR    R0,R0                                                    00012600
         IC    R0,RPLRTNCD                                              00012700
         CALL  PRINTF,(MSG3,(0)),VL                                     00012800
*                                                                       00012900
         XR    R0,R0                                                    00013000
         IC    R0,RPLFDBK2                                              00013100
         CALL  PRINTF,(MSG4,(0)),VL                                     00013200
*                                                                       00013300
         LH    R0,RPL6RCPR                                              00013400
         CALL  PRINTF,(MSG5,(0)),VL                                     00013500
*                                                                       00013600
         LH    R0,RPL6RCSC                                              00013700
         CALL  PRINTF,(MSG6,(0)),VL                                     00013800
*                                                                       00013900
         DROP  R4                                                       00014000
         DROP  R5                                                       00014100
*                                                                       00014200
* RESTORE REGISTERS AND RETURN                                          00014300
*                                                                       00014400
         EDCEPIL                                                        00014500
*                                                                       00014600
REPLY    DS    CL1                                                      00014700
         DS    0F                                                       00014800
REPLYECB DS    F                                                        00014900
RCDSAVE  DS    18F                                                      00015000
MSG3     DC    CL44'RETURN FROM VTAM APPCCMD, RPLRTNCD = <%X> '         00015100
         DC    XL1'0D'    NEW LINE                                      00015200
         DC    XL1'00'                                                  00015300
MSG4     DC    CL44'RETURN FROM VTAM APPCCMD, RPLFDBK2 = <%X> '         00015400
         DC    XL1'0D'    NEW LINE                                      00015500
         DC    XL1'00'                                                  00015600
MSG5     DC    CL44'RETURN FROM VTAM APPCCMD, RPL6RCPR = <%X> '         00015700
         DC    XL1'0D'    NEW LINE                                      00015800
         DC    XL1'00'                                                  00015900
MSG6     DC    CL44'RETURN FROM VTAM APPCCMD, RPL6RCSC = <%X> '         00016000
         DC    XL1'0D'        NEW LINE                                  00016100
         DC    XL1'00'                                                  00016200
         LTORG                                                          00016300
         DROP  R3                                                       00016400
*                                                                       00016500
*                                                                       00016600
* DSECTS                                                                00016700
*                                                                       00016800
         IFGACB AM=VTAM                                                 00016900
         IFGRPL AM=VTAM                                                 00017000
         END                                                            00017100
* [------ vtamrcv.asm  File Begin here ]	







**************************************************************          00000100
* VTAMRCV  CSECT  FOR 'C' INTERFACE                                     00000200
**************************************************************          00000300
*                                                                       00000400
* VTAMRCV RECEIVES 1 PARAMETER                                          00000500
*    RECEIVE BUFFER ADDR                                                00000600
*    RECEIVE BUFFER LENGTH                                              00000700
*                                                                       00000800
* THIS ROUTINE DOES THE FOLLOWING:                                      00000900
*    RECEIVE FMH5 HEADER                                                00001000
*    RECEIVE DATA                                                       00001100
*    RECEIVE DEALLOCATE                                                 00001200
*    SEND CONFIRMED                                                     00001300
*                                                                       00001400
* RETURN VALUE IN R15                                                   00001500
*        0 = SUCCESS                                                    00001600
*    OTHER = NON-SUCCESSFUL                                             00001700
*                                                                       00001800
**************************************************************          00001900
R0  EQU 0                                                               00002000
R1  EQU 1                                                               00002100
R2  EQU 2                                                               00002200
R3  EQU 3                                                               00002300
R4  EQU 4                                                               00002400
R5  EQU 5                                                               00002500
R6  EQU 6                                                               00002600
R7  EQU 7                                                               00002700
R8  EQU 8                                                               00002800
R9  EQU 9                                                               00002900
R10 EQU 10                                                              00003000
R11 EQU 11                                                              00003100
R12 EQU 12                                                              00003200
R13 EQU 13                                                              00003300
R14 EQU 14                                                              00003400
R15 EQU 15                                                              00003500
*                                                                       00003600
* SAVE REGS AND ESTABLISH ADDRESSABILITY                                00003700
*                                                                       00003800
VTAMRCV  EDCPROL                                                        00003900
         BALR  R3,R0                                                    00004000
         USING *,R3                                                     00004100
*                                                                       00004200
* GET PARAMETERS                                                        00004300
*                                                                       00004400
         L     R4,0(R1)       GET RECEIVE BUFFER ADDR                   00004500
         ST    R4,P_RCVBUF                                              00004600
         L     R4,4(R1)       GET RECEIVE DATA LENGTH ADDR              00004700
         ST    R4,P_RCVLEN                                              00004800
*                                                                       00004900
* APPC RECEIVE FMH 5                                                    00005000
*                                                                       00005100
*        CALL   PRINTF,(MSG6),VL                                        00005200
*                                                                       00005300
         MVI   FMH5BUF,C' '                                             00005400
         MVC   FMH5BUF+1(255),FMH5BUF                                   00005500
         MVC   FMH5LEN,=H'256'                                          00005600
         CALL  VTRCV5,(FMH5BUF,FMH5LEN,CONVID,FMH5LUNM,RC)              00005700
*                                                                       00005800
         L     R15,RCLU62                                               00005900
         LTR   R15,R15                                                  00006000
         BNZ   RCVX                                                     00006100
*                                                                       00006200
* DISPLAY THE RETURNED LUNAME AND TPNAME                                00006300
*                                                                       00006400
         LA    R5,FMH5BUF                                               00006500
         USING ISTFM5,R5                                                00006600
         MVC   RCV5M1A(8),FM5TPNAM                                      00006700
         DROP  R5                                                       00006800
*        CALL  PRINTF,(RCV5MSG1),VL                                     00006900
*                                                                       00007000
         MVC   RCV5M2A,FMH5LUNM                                         00007100
*        CALL  PRINTF,(RCV5MSG2),VL                                     00007200
*                                                                       00007300
* APPC RECEIVE DATA                                                     00007400
*                                                                       00007500
*        CALL  PRINTF,(MSG7),VL                                         00007600
         CALL  VTRCV,(CONVID,RBUF,RBUFLEN,RCVLEN,WHATRCV,RC)            00007700
*                                                                       00007800
         L     R15,RCLU62                                               00007900
         LTR   R15,R15        CHECK IF OK TO CONTINUE                   00008000
         BNZ   RCVX           NO - QUIT                                 00008100
*                                                                       00008200
* DISPLAY RESULTS                                                       00008300
*                                                                       00008400
         XR    R0,R0                                                    00008500
         IC    R0,WHATRCV                                               00008600
*        CALL  PRINTF,(RCVMSG1,(0)),VL                                  00008700
*                                                                       00008800
         LH    R5,RCVLEN      GET LENGTH AND                            00008900
         S     R5,=F'4'       SUBTRACT FOR THE LL/GDSID                 00009000
*        CALL  PRINTF,(RCVMSG2,(5)),VL                                  00009100
*                                                                       00009200
* RETURN THE IS/2 MESSAGE AND LENGTH BACK TO CALLING ROUTINE            00009300
*                                                                       00009400
         L     R4,P_RCVBUF    GET THE CALLERS RECEIVE BUFFER ADDR       00009500
         L     R9,P_RCVLEN    RETURN THE LENGTH                         00009600
         CH    R5,0(R9)       TEST IF RETURNED LENGTH > BUFFER          00009700
         BNH   RCV11          NO - USE RETURNED LENGTH                  00009800
         LH    R5,0(R9)       ELSE TRUNCATE TO BUFFER SIZE              00019900
RCV11    STH   R5,0(R9)       RETURN LENGTH TO CALLER                   00010000
         LA    R6,RBUFDATA    GET RBUF DATA PORTION ADDR                00010100
         LR    R7,R5          SET SEND LENGTH                           00010200
         MVCL  R4,R6          RETURN DATA TO THE CALLER                 00010300
*                                                                       00010400
* CONTINUE TO RECEIVE UNTIL DEALLOCATE RECEIVED                         00010500
*                                                                       00010600
RCV21    TM    WHATRCV,B'00000100' TEST FOR DEALLOCATE RECEIVED         00010700
         BO    RCV31                                                    00010800
         CALL  VTRCV,(CONVID,RBUF,RBUFLEN,RCVLEN,WHATRCV,RC)            00010900
*                                                                       00011000
         L     R15,RCLU62                                               00011100
         LTR   R15,R15        CHECK IF OK TO CONTINUE                   00011200
         BNZ   RCVX           NO - QUIT                                 00011300
         B     RCV21          CONTINUE LOOP                             00011400
*                                                                       00011500
* SEND CONFIRMED                                                        00011600
*                                                                       00011700
RCV31    EQU   *                                                        00011800
*        CALL  PRINTF,(MSG8),VL                                         00011900
         CALL  VTCONFD,(CONVID,RC)                                      00012000
*                                                                       00012100
         L     R15,RCLU62                                               00012200
         LTR   R15,R15        CHECK IF OK TO CONTINUE                   00012300
         BNZ   RCVX           NO - QUIT                                 00012400
*                                                                       00012500
* RESTORE REGISTERS AND RETURN                                          00012600
*                                                                       00012700
RCVX     EDCEPIL                                                        00012800
*                                                                       00012900
*  SEND CSECT WORK AREAS                                                00013000
*                                                                       00013100
CONVID   DS    F             CONVERSATION ID                            00013200
*                                                                       00013300
*  PASSED PARAMETER ADDRESSES                                           00013400
*                                                                       00013500
P_RCVBUF DS    F                                                        00013600
P_RCVLEN DS    F                                                        00013700
*                                                                       00013800
*  RETURN CODE STRUCTURE (1 DOUBLE WORD)                                00013900
*                                                                       00014000
RC       DS    0D                                                       00014100
RCPRI    DS    0F                                                       00014200
RCAPPL   DS    H                                                        00014300
RCVMAJRC DS    CL1                                                      00014400
RCVFDBK2 DS    CL1                                                      00014500
RCLU62   DS    0F                                                       00014600
RCLU6PRI DS    H                                                        00014700
RCLU6SEC DS    H                                                        00014800
*                                                                       00014900
*  FMH 5 AREA                                                           00015000
*                                                                       00015100
FMH5LEN  DS    H                                                        00015200
FMH5BUF  DS    CL256                                                    00015300
FMH5LUNM DS    CL8            RETURNED LUNAME                           00015400
*                                                                       00015500
*************** DISPLAY MESSAGES *****************************          00015600
*                                                                       00015700
* DISPLAY CONTROL BLOCKS FOR VDISP DISPLAY CALLS                        00015800
*                                                                       00015900
*************** MAIN MESSAGES ********************************          00016000
*                                                                       00016100
MSG6     DC    CL33'CALLING APPCCMD FOR RECEIVE FMH 5'                  00016200
         DC    XL1'0D'                                                  00016300
         DC    XL1'00'                                                  00016400
MSG7     DC    CL27'CALLING APPCCMD FOR RECEIVE'                        00016500
         DC    XL1'0D'                                                  00016600
         DC    XL1'00'                                                  00016700
MSG8     DC    CL29'CALLING APPCCMD FOR CONFIRMED'                      00016800
         DC    XL1'0D'                                                  00016900
         DC    XL1'00'                                                  00017000
*                                                                       00017100
*************** RECEIVE MESSAGES *****************************          00017200
*                                                                       00017300
RCVMSG1  DC    CL32'WHAT RECEIVED INDICATOR = X<%X> '                   00017400
         DC    XL1'0D'                                                  00017500
         DC    XL1'00'                                                  00017600
RCVMSG2  DC    CL30'RECEIVE BUFFER LENGTH = X<%X> '                     00017700
         DC    XL1'0D'                                                  00017800
         DC    XL1'00'                                                  00017900
RCVMSG3  DC    CL14'RECEIVED DATA:'                                     00018000
         DC    XL1'0D'                                                  00018100
         DC    XL1'00'                                                  00018200
RCVMSG4  DC    CL40'123456789.123456789.123456789.123456789.'           00018300
         DC    CL38'123456789.123456789.123456789.12345678'             00018400
         DC    XL1'0D'                                                  00018500
         DC    XL1'00'                                                  00018600
*                                                                       00018700
*************** RECEIVE FMH5 MESSAGES ************************          00018800
*                                                                       00018900
*                                                                       00019000
RCV5MSG1 DC    CL14'FMH5 TPNAME = '                                     00019100
RCV5M1A  DC    CL9' '                                                   00019200
         DC    XL1'00'        NULL TERMINATOR                           00019300
*                                                                       00019400
RCV5MSG2 DC    CL14'FMH5 LUNAME = '                                     00019500
RCV5M2A  DC    CL8' '                                                   00019600
         DC    XL1'0D'                                                  00019700
         DC    XL1'00'        NULL TERMINATOR                           00019800
*                                                                       00019900
*************** END OF MESSAGES ******************************          00020000
*                                                                       00020100
* RECEIVE FIELDS                                                        00020200
*                                                                       00020300
RCVLEN   DS    H              ACTUAL RECEIVED LENGTH                    00020400
WHATRCV  DS    XL1            WHAT RECEIVED INDICATOR                   00020500
RBUFLEN  DC    H'1024'        SUPPLIED BUFFER LENGTH                    00020600
         DS    0F                                                       00020700
RBUF     DS    0CL1024        PLACED HERE FOR BASE/DISPLACEMENT         00020800
RBUFLL   DS    H                                                        00020900
RBUFGDS  DS    H                                                        00021000
RBUFDATA DS    CL1020                                                   00021100
*                                                                       00021200
         LTORG                                                          00021300
         DROP  R3                                                       00021400
*                                                                       00021500
*  DSECTS                                                               00021600
*                                                                       00021700
         IFGACB AM=VTAM                                                 00021800
         IFGRPL AM=VTAM                                                 00021900
         ISTFM5                                                         00022000
         ISTSLCNS                                                       00022100
         END                                                            00022200
* [------ vtamsend.asm  File Begin here ]	







**************************************************************          00000100
* VTAMSEND CSECT FOR 'C' INTERFACE                                      00000200
**************************************************************          00000300
*                                                                       00000400
* VTAMSEND RECEIVES 5 PARAMETERS                                        00000500
*                                                                       00000600
*        APPC PARTNER LU NAME ADDR                                      00000700
*        APPC PARTNER TP NAME ADDR                                      00000800
*        APPC MODE NAME ADDR                                            00000900
*        VTAM MESSAGE BUFFER ADDR                                       00001000
*        VTAM MESSAGE LENGTH ADDR (HALF-WORD VALUE)                     00001100
*                                                                       00001200
* THIS ROUTINE DOES THE FOLLOWING:                                      00001300
*                                                                       00001400
*        BUILD FMH5 HEADER                                              00001500
*        ALLOCATE CONVERSATION                                          00001600
*        BUILD APPC MESSAGE                                             00001700
*        SEND MESSAGE                                                   00001800
*        DEALLOCATE CONVERSATION                                        00001900
*                                                                       00002000
* RETURN VALUE IN R15                                                   00002100
*        0 = SUCCESS                                                    00002200
*    OTHER = NON-SUCCESSFUL                                             00002300
*                                                                       00002400
**************************************************************          00002500
R0  EQU 0                                                               00002600
R1  EQU 1                                                               00002700
R2  EQU 2                                                               00002800
R3  EQU 3                                                               00002900
R4  EQU 4                                                               00003000
R5  EQU 5                                                               00003100
R6  EQU 6                                                               00003200
R7  EQU 7                                                               00003300
R8  EQU 8                                                               00003400
R9  EQU 9                                                               00003500
R10 EQU 10                                                              00003600
R11 EQU 11                                                              00003700
R12 EQU 12                                                              00003800
R13 EQU 13                                                              00003900
R14 EQU 14                                                              00004000
R15 EQU 15                                                              00004100
*                                                                       00004200
* SAVE REGS AND ESTABLISH ADDRESSABILITY                                00004300
*                                                                       00004400
VTAMSEND EDCPROL                                                        00004500
         BALR  R3,R0                                                    00004600
         USING *,R3                                                     00004700
*                                                                       00004800
* GET PARAMETERS                                                        00004900
*                                                                       00005000
         L     R4,0(R1)       GET PARTNER LU                            00005100
         ST    R4,P_PARTLU                                              00005200
         L     R4,4(R1)       GET PARTNER TP NAME                       00005300
         ST    R4,P_PARTTP                                              00005400
         L     R4,8(R1)       GET MODENAME                              00005500
         ST    R4,P_MODENM                                              00005600
         L     R4,12(R1)      GET MESSAGE BUFFER                        00005700
         ST    R4,P_SNDBUF                                              00005800
         L     R4,16(R1)      GET MESSAGE LENGTH                        00005900
         ST    R4,P_SNDLL                                               00006000
*                                                                       00006100
* BUILD THE FMH5 HEADER                                                 00006200
*                                                                       00006300
         LA    R11,FMH5BUF                                              00006400
         USING ISTFM5,R11                                               00006500
         MVI   FM5BASE,0                                                00006600
         MVC   FM5BASE+1(17),FM5BASE                                    00006700
         MVI   FM5LENTH,18                                              00006800
         MVI   FM5FLAG1,FM5TYPE5                                        00006900
         MVI   FM5TYPE,X'02'                                            00007000
         MVI   FM5TYPE+1,X'FF'                                          00007100
         MVI   FM5FLAG2,0                                               00007200
         MVI   FM5LNFLP,3                                               00007300
         MVI   FM5RSCTP,FM5MAPED                                        00007400
         MVI   FM5FLAG3,FM5CONFM                                        00007500
         MVI   FM5LNTPN,8                                               00007600
         L     R5,P_PARTTP       BUILD THE TPNAME FROM                  00007700
         MVC   FM5TPNAM(8),0(R5) PASSED PARAMETER                       00007800
         DROP  R11                                                      00007900
*                                                                       00008000
         MVC   FMH5LEN,=H'18'                                           00008100
*                                                                       00008200
*  APPC ALLOCATE                                                        00008300
*                                                                       00008400
*        CALL  PRINTF,(MSG3),VL                                         00008500
         L     R4,P_PARTLU                                              00008600
         L     R5,P_MODENM                                              00008700
         CALL  VTALLOC,((4),(5),FMH5BUF,FMH5LEN,CONVID,RC)              00008800
*                                                                       00008900
         L     R15,RCLU62                                               00009000
         LTR   R15,R15        CHECK IF OK TO CONTINUE                   00009100
         BNZ   SENDX          NO - QUIT                                 00009200
*                                                                       00009300
* BUILD SEND BUFFER                                                     00009400
*                                                                       00009500
         L     R4,P_SNDLL                                               00009600
         XR    R5,R5                                                    00009700
         LH    R5,0(R4)       R5 = VTAM MSG LENGTH                      00009800
         LA    R6,4(R5)       R6 = VTAM + (APPC GDS VARIABLE)           00009900
         STH   R6,SBLL                                                  00010000
*                                                                       00010100
         L     R4,P_SNDBUF                                              00010200
         LA    R6,SBDATA                                                00010300
         LR    R7,R5                                                    00010400
         MVCL  R6,R4                                                    00010500
*                                                                       00010600
         MVC   SBGDSID,=XL2'12FF'                                       00010700
*                                                                       00010800
*        CALL   PRINTF,(MSG4),VL                                        00010900
         L     R4,P_SNDBUF                                              00011000
         CALL  VTSEND,(CONVID,SBUF,SBLL,RC)                             00011100
*                                                                       00011200
         L     R15,RCLU62                                               00011300
         LTR   R15,R15        CHECK IF OK TO CONTINUE                   00011400
         BNZ   SENDX          NO - QUIT                                 00011500
*                                                                       00011600
* APPC DEALLOCATE                                                       00011700
*                                                                       00011800
*        CALL  PRINTF,(MSG5),VL                                         00011900
         CALL  VTDALOC,(CONVID,RC)                                      00012000
*                                                                       00012100
         L     R15,RCLU62                                               00012200
         LTR   R15,R15        CHECK IF OK TO CONTINUE                   00012300
         BNZ   SENDX          NO - QUIT                                 00012400
*                                                                       00012500
* RESTORE REGISTERS AND RETURN                                          00012600
*                                                                       00012700
SENDX    EDCEPIL                                                        00012800
*                                                                       00012900
*  SEND CSECT WORK AREAS                                                00013000
*                                                                       00013100
CONVID   DS   F               CONVERSATION ID                           00013200
*                                                                       00013300
*  PASSED PARAMETER ADDRESSES                                           00013400
*                                                                       00013500
P_PARTLU DS   F                                                         00013600
P_PARTTP DS   F                                                         00013700
P_MODENM DS   F                                                         00013800
P_SNDBUF DS   F                                                         00013900
P_SNDLL  DS   F                                                         00014000
*                                                                       00014100
*  RETURN CODE STRUCTURE (1 DOUBLE WORD)                                00014200
*                                                                       00014300
RC       DS   0D                                                        00014400
RCPRI    DS   0F                                                        00014500
RCAPPL   DS   H                                                         00014600
RCVMAJRC DS   CL1                                                       00014700
RCVFDBK2 DS   CL1                                                       00014800
RCLU62   DS   0F                                                        00014900
RCLU6PRI DS   H                                                         00015000
RCLU6SEC DS   H                                                         00015100
*                                                                       00015200
*  FMH 5 AREA                                                           00015300
*                                                                       00015400
FMH5LEN  DS   H                                                         00015500
FMH5BUF  DS   CL256                                                     00015600
FMH5LUNM DS   CL8             RETURNED LUNAME                           00015700
*                                                                       00015800
*  SEND BUFFER                                                          00015900
*                                                                       00016000
         DS    0F                                                       00016100
SBUF     DS    0CL256                                                   00016200
SBLL     DS    H                                                        00016300
SBGDSID  DS    H                                                        00016400
SBDATA   DS    CL252                                                    00016500
*                                                                       53116600
*************** DISPLAY MESSAGES *****************************          00016700
*                                                                       00016800
MSG3     DC    CL25'CALLING APPCCMD FOR ALLOC'                          00016900
         DC    XL1'0D'                                                  00017000
         DC    XL1'00'                                                  00017100
MSG4     DC    CL24'CALLING APPCCMD FOR SEND'                           00017200
         DC    XL1'0D'                                                  00017300
         DC    XL1'00'                                                  00017400
MSG5     DC    CL27'CALLING APPCCMD FOR DEALLOC'                        00017500
         DC    XL1'0D'                                                  00017600
         DC    XL1'00'                                                  00017700
*                                                                       00017800
         LTORG                                                          00017900
         DROP  R3                                                       00018000
*                                                                       00018100
*  DSECTS                                                               00018200
*                                                                       00018300
         IFGACB AM=VTAM                                                 00018400
         IFGRPL AM=VTAM                                                 00018500
         ISTFM5                                                         00018600
         ISTSLCNS                                                       00018700
    END                                                                 00018800
* [------ vtamterm.asm  File Begin here ]	







**************************************************************          00000100
* VTAMTERM CSECT FOR 'C' INTERFACE                                      00000200
**************************************************************          00000300
*                                                                       00000400
* THIS ROUTINE CLOSES THE VTAM ACB                                      00000500
*                                                                       00000600
* RETURN VALUE IN R15                                                   00000700
*        0 = SUCCESS                                                    00000800
*    OTHER = NON-SUCCESSFUL                                             00000900
*                                                                       00001000
**************************************************************          00001100
R0  EQU 0                                                               00001200
R1  EQU 1                                                               00001300
R2  EQU 2                                                               00001400
R3  EQU 3                                                               00001500
R4  EQU 4                                                               00001600
R5  EQU 5                                                               00001700
R6  EQU 6                                                               00001800
R7  EQU 7                                                               00001900
R8  EQU 8                                                               00002000
R9  EQU 9                                                               00002100
R10 EQU 10                                                              00002200
R11 EQU 11                                                              00002300
R12 EQU 12                                                              00002400
R13 EQU 13                                                              00002500
R14 EQU 14                                                              00002600
R15 EQU 15                                                              00002700
*                                                                       00002800
* SAVE REGS AND ESTABLISH ADDRESSABILITY                                00002900
*                                                                       00003000
VTAMTERM EDCPROL                                                        00003100
         BALR  R3,R0                                                    00003200
         USING *,R3                                                     00003300
*                                                                       00003400
         CALL  VTTERM                                                   00003500
*                                                                       00003600
* RESTORE REGISTERS AND RETURN                                          00003700
*                                                                       00003800
         EDCEPIL                                                        00003900
*                                                                       00004000
*  RETURN CODE STRUCTURE (1 DOUBLE WORD)                                00004100
*                                                                       00004200
RC       DS   0D                                                        00004300
RCPRI    DS   0F                                                        00004400
RCAPPL   DS   H                                                         00004500
RCVMAJRC DS   CL1                                                       00004600
RCVFDBK2 DS   CL1                                                       00004700
RCLU62   DS   0F                                                        00004800
RCLU6PRI DS   H                                                         00004900
RCLU6SEC DS   H                                                         00005000
         LTORG                                                          00005100
         DROP  R3                                                       00005200
*                                                                       00005300
*  DSECTS                                                               00005400
*                                                                       00005500
         IFGACB AM=VTAM                                                 00005600
         IFGRPL AM=VTAM                                                 00005700
         ISTFM5                                                         00005800
         ISTSLCNS                                                       00005900
         END                                                            00006000
* [------ vtamutil.asm  File Begin here ]	







**************************************************************          00000100
* VTAMUTIL - CSECTS FOR EXECUTING THE VTAM APPC MACROS                  00000200
**************************************************************          00000300
R0  EQU 0                                                               00000400
R1  EQU 1                                                               00000500
R2  EQU 2                                                               00000600
R3  EQU 3                                                               00000700
R4  EQU 4                                                               00000800
R5  EQU 5                                                               00000900
R6  EQU 6                                                               00001000
R7  EQU 7                                                               00001100
R8  EQU 8                                                               00001200
R9  EQU 9                                                               00001300
R10 EQU 10                                                              00001400
R11 EQU 11                                                              00001500
R12 EQU 12                                                              00001600
R13 EQU 13                                                              00001700
R14 EQU 14                                                              00001800
R15 EQU 15                                                              00001900
*                                                                       00002000
         PRINT NOGEN                                                    00002100
*                                                                       00002200
*                                                                       00002300
**************************************************************          00002400
VTINIT   CSECT                                                          00002500
**************************************************************          00002600
*                                                                       00002700
* VTINIT:                                                               00002800
*                                                                       00002900
* THIS CSECT INITIALIZES THE GLOBAL DATA AREAS AND OPENS THE ACB        00003000
*                                                                       00003100
* REGISTERS AT ENTRY:                                                   00003200
*    R13 = HSA                                                          00003300
*    R14 = RETURN ADDRESS                                               00003400
*    R15 = ENTRY ADDRESS                                                00003500
*    R1  = POINTER TO ADDRESS LIST                                      00003600
*          PARM1 = APPLICATION NAME ADDR (LOCAL LUNAME)                 00003700
*          PARM2 = RETURN CODE ADDR                                     00003800
*                                                                       00003900
*  RETURN VALUES:                                                       00004000
*    R15 = VTAM MAJOR/FEEDBACK2 RC                                      00004100
*    R0  = LU6.2 RC                                                     00004200
*                                                                       00004300
**************************************************************          00004400
*                                                                       00004500
*        ESTABLISH ADDRESSABILITY AND SETUP SAVEAREA LINK               00004600
*                                                                       00004700
         USING *,R3                                                     00004800
         STM   R14,R12,12(R13)                                          00004900
         LR    R3,R15                                                   00005000
         LA    R11,VTINITSV                                             00005100
         ST    R11,8(R13)                                               00005200
         ST    R13,4(R11)                                               00005300
         LR    R13,R11                                                  00005400
*                                                                       00005500
* GET THE PARAMETERS                                                    00005600
*                                                                       00005700
         L     R4,0(R1)   ORIG LUNAME ADDR                              00005800
         L     R5,4(R1)   RETURN CODE ADDR                              00005900
         ST    R5,RCPARM1                                               00006000
*                                                                       00006100
*        OPEN THE ACB                                                   00006200
*                                                                       00006300
         CALL  OPENACB,((4))                                            00006400
         LTR   R15,R15                                                  00006500
         BNZ   VTIX                                                     00006600
*                                                                       00006700
* ALLOW AUTO SESSION STARTUP BY VTAM                                    00006800
*                                                                       00006900
         CALL  GETRPL                                                   00007000
         LTR   R15,R15        TEST GOOD RC                              00007100
         BNZ   VTIX           NO - EXIT ROUTINE                         00007200
         LR    R5,R0                                                    00007300
         SETLOGON RPL=(5),OPTCD=START                                   00007400
*                                                                       00007500
*        RESTORE REGISTERS AND EXIT PROGRAM                             00007600
*                                                                       00007700
VTIX     L     R11,RCPARM1                                              00007800
         ST    R15,0(R11)     RETURN PRIMARY RC                         00007900
         ST    R0,4(R11)      RETURN SECONDARY RC                       00008000
*                                                                       00008100
         L     R13,4(R13)                                               00008200
         L     R14,12(R13)                                              00008300
         LM    R1,R12,24(R13) RC = R15/R0                               00008400
         BR    R14                                                      00008500
VTINITSV DS    18F                                                      00008600
RCPARM1  DS    F                                                        00008700
         LTORG                                                          00008800
         DROP  R3                                                       00008900
*                                                                       00009000
**************************************************************          00009100
VTTERM   CSECT                                                          00009200
**************************************************************          00009300
*                                                                       00009400
* VTTERM:                                                               00009500
*                                                                       00009600
* THIS CSECT CLOSES THE ACB                                             00009700
*                                                                       00009800
* REGISTERS AT ENTRY:                                                   00009900
*    R13 = HSA                                                          00010000
*    R14 = RETURN ADDRESS                                               00010100
*    R15 = ENTRY ADDRESS                                                00010200
*    R1  = POINTER TO ADDRESS LIST                                      00010300
*          NO PARAMETERS                                                00010400
*                                                                       00010500
*  RETURN VALUES:                                                       00010600
*    R15 = VTAM MAJOR/FEEDBACK2 RC                                      00010700
*    R0  = LU6.2 RC                                                     00010800
*                                                                       00010900
**************************************************************          00011000
*                                                                       00011100
*        ESTABLISH ADDRESSABILITY AND SETUP SAVEAREA LINK               00011200
*                                                                       00011300
         USING *,R3                                                     00011400
         STM   R14,R12,12(R13)                                          00011500
         LR    R3,R15                                                   00011600
         LA    R11,VTTERMSV                                             00011700
         ST    R11,8(R13)                                               00011800
         ST    R13,4(R11)                                               00011900
         LR    R13,R11                                                  00012000
*                                                                       00012100
*        CLOSE THE ACB                                                  00012200
*                                                                       00012300
         CALL  CLOSEACB                                                 00012400
*                                                                       00012500
*        RESTORE REGISTERS AND EXIT PROGRAM                             00012600
*                                                                       00012700
         L     R13,4(R13)                                               00012800
         L     R14,12(R13)                                              00012900
         LM    R1,R12,24(R13) RC = R15/R0                               00013000
         BR    R14                                                      00013100
VTTERMSV DS    18F                                                      00013200
         LTORG                                                          00013300
         DROP  R3                                                       00013400
*                                                                       00013500
**************************************************************          00013600
VTCNOS   CSECT                                                          00013700
**************************************************************          00013800
*                                                                       00013900
* VTCNOS:                                                               00014000
*                                                                       00014100
* THIS CSECT PERFORMS VTAM CNOS MACRO                                   00014200
*                                                                       00014300
* REGISTERS AT ENTRY:                                                   00014400
*    R13 = HSA                                                          00014500
*    R14 = RETURN ADDRESS                                               00014600
*    R15 = ENTRY ADDRESS                                                00014700
*    R1  = POINTER TO ADDRESS LIST                                      00014800
*          PARM1 = PARTNER LUNAME ADDR                                  00014900
*          PARM2 = MODENAME ADDR                                        00015000
*          PARM3 = CNOS CONTROL BLOCK ADDR                              00015100
*          PARM4 = RETURN CODE ADDR                                     00015200
*                                                                       00015300
*  RETURN VALUES:                                                       00015400
*    R15 = VTAM MAJOR/FEEDBACK2 RC                                      00015500
*    R0  = LU6.2 RC                                                     00015600
*                                                                       00015700
**************************************************************          00015800
*                                                                       00015900
*        ESTABLISH ADDRESSABILITY AND SETUP SAVEAREA LINK               00016000
*                                                                       00016100
         USING *,R3                                                     00016200
         STM   R14,R12,12(R13)                                          00016300
         LR    R3,R15                                                   00016400
         LA    R11,VTCNOSSV                                             00016500
         ST    R11,8(R13)                                               00016600
         ST    R13,4(R11)                                               00016700
         LR    R13,R11                                                  00016800
*                                                                       00016900
* GET THE PARAMETERS                                                    00017000
*                                                                       00017100
         L     R6,0(R1)       PARTNER LUNAME ADDR                       00017200
         L     R7,4(R1)       MODENAME ADDR                             00017300
         L     R8,8(R1)       CNOS CONTROL BLOCK ADDR                   00017400
         L     R9,12(R1)      RETURN CODE ADDR                          00017500
         ST    R9,RCPARM2                                               00017600
*                                                                       00017700
* GET THE RPL FOR THE PASSED CONVID                                     00017800
*                                                                       00017900
         CALL  GETRPL         GET A NEW RPL                             00018000
         LTR   R15,R15        TEST GOOD RC                              00018100
         BNZ   VTCNE          NO - EXIT ROUTINE                         00018200
         LR    R4,R0          RPL ADDR IS RETURNED IN R0                00018300
*                                                                       00018400
* MOVE LUNAME AND MODENAME INTO THE RPL                                 00018500
*                                                                       00018600
         USING IFGRPL,R4                                                00018700
         USING ISTRPL6X,R5                                              00018800
         L     R5,RPLAAREA                                              00018900
         MVC   RPL6LU,0(R6)                                             00019000
         MVC   RPL6MODE,0(R7)                                           00019100
         DROP  R4                                                       00019200
         DROP  R5                                                       00019300
*                                                                       00019400
* APPC CNOS                                                             00019500
*                                                                       00019600
         APPCCMD CONTROL=OPRCNTL,                                      X00019700
               QUALIFY=CNOS,                                           X00019800
               RPL=(4),                                                X00019900
               AREA=(8),                                               X00020000
               RECLEN=7                                                 00020100
*                                                                       00020200
* CHECK THE RETURN CODE - PASS R15 RC BACK TO CALLER                    00020300
*                                                                       00020400
         CALL  RCCHECK,((4))  PASS RPL TO CHECK ROUTINE                 00020500
         LTR   R15,R15        CHECK VTAM RC                             00020600
         BNZ   VTCNE                                                    00020700
         LTR   R0,R0          CHECK LU62 RC                             00020800
         BZ    VTCNX                                                    00020900
         C     R0,=F'1'       CHECK PRI=0,SEC=1                         00021000
         BE    VTCNX          YES - OK                                  00021100
*                                                                       00021200
VTCNE    STM   R15,R0,VTCNOSRC                                          00021300
         CALL  RCDISP,((4))                                             00021400
         LM    R15,R0,VTCNOSRC                                          00021500
*                                                                       00021600
*        RESTORE REGISTERS AND EXIT PROGRAM                             00021700
*                                                                       00021800
VTCNX    L     R11,RCPARM2                                              00021900
         ST    R15,0(R11)     RETURN PRIMARY RC                         00022000
         ST    R0,4(R11)      RETURN SECONDARY RC                       00022100
*                                                                       00022200
         L     R13,4(R13)                                               00022300
         L     R14,12(R13)                                              00022400
         LM    R1,R12,24(R13) RC = R15/R0                               00022500
         BR    R14                                                      00022600
VTCNOSSV DS    18F                                                      00022700
VTCNOSRC DS    2F                                                       00022800
RCPARM2  DS    F                                                        00022900
         LTORG                                                          00023000
         DROP  R3                                                       00023100
*                                                                       00023200
**************************************************************          00023300
VTALLOC  CSECT                                                          00023400
**************************************************************          00023500
*                                                                       00023600
* VTALLOC:                                                              00023700
*                                                                       00023800
* THIS CSECT PERFORMS VTAM ALLOCATE MACRO                               00023900
*                                                                       00024000
* REGISTERS AT ENTRY:                                                   00024100
*    R13 = HSA                                                          00024200
*    R14 = RETURN ADDRESS                                               00024300
*    R15 = ENTRY ADDRESS                                                00024400
*    R1  = POINTER TO ADDRESS LIST                                      00024500
*          PARM1 = PARTNER LUNAME ADDR                                  00024600
*          PARM2 = MODENAME ADDR                                        00024700
*          PARM3 = FMH5 BUFFER ADDR                                     00024800
*          PARM4 = FMH5 BUFFER LEN ADDR                                 00024900
*          PARM5 = RETURN CONVID ADDR                                   00025000
*          PARM6 = RETURN CODE ADDR                                     00025100
*                                                                       00025200
*  RETURN VALUES:                                                       00025300
*    R15 = VTAM MAJOR/FEEDBACK2 RC                                      00025400
*    R0  = LU6.2 RC                                                     00025500
*                                                                       00025600
**************************************************************          00025700
*                                                                       00025800
*        ESTABLISH ADDRESSABILITY AND SETUP SAVEAREA LINK               00025900
*                                                                       00026000
         USING *,R3                                                     00026100
         STM   R14,R12,12(R13)                                          00026200
         LR    R3,R15                                                   00026300
         LA    R11,VTALOCSV                                             00026400
         ST    R11,8(R13)                                               00026500
         ST    R13,4(R11)                                               00026600
         LR    R13,R11                                                  00026700
*                                                                       00026800
* GET THE PARAMETERS                                                    00026900
*                                                                       00027000
         L     R6,0(R1)       PARTNER LUNAME ADDR                       00027100
         L     R7,4(R1)       MODENAME ADDR                             00027200
         L     R8,8(R1)       FMH5 BUFFER ADDR                          00027300
         L     R9,12(R1)      FMH5 BUFFER LENGTH ADDR                   00027400
         LH    R10,0(R9)      PICK UP THE LENGTH VALUE                  00027500
         L     R11,16(R1)     RETURN CONVID ADDR                        00027600
         L     R5,20(R1)      RETURN CODE ADDR                          00027700
         ST    R5,RCPARM3                                               00027800
*                                                                       00027900
* GET A NEW RPL                                                         00028000
*                                                                       00028100
         CALL  GETRPL         GET A NEW RPL                             00028200
         LTR   R15,R15        TEST GOOD RC                              00028300
         BNZ   VTALX          NO - EXIT ROUTINE                         00028400
         LR    R4,R0          RPL ADDR IS RETURNED IN R0                00028500
*                                                                       00028600
* MOVE LUNAME AND MODENAME INTO THE RPL                                 00028700
*                                                                       00028800
         USING IFGRPL,R4                                                00028900
         USING ISTRPL6X,R5                                              00029000
         L     R5,RPLAAREA                                              00029100
         MVC   RPL6LU,0(R6)                                             00029200
         MVC   RPL6MODE,0(R7)                                           00029300
         DROP  R4                                                       00029400
         DROP  R5                                                       00029500
*                                                                       00029600
*  APPC ALLOCATE                                                        00029700
*                                                                       00029800
         APPCCMD CONTROL=ALLOC,                                        X00029900
               QUALIFY=ALLOCD,                                         X00030000
               OPTCD=SYN,                                              X00030100
               CONMODE=CS,                                             X00030200
               RPL=(4),                                                X00030300
               AREA=(8),                                               X00030400
               RECLEN=(10)                                              00030500
*                                                                       00030600
* CHECK THE RETURN CODE - PASS R15 RC BACK TO CALLER                    00030700
*                                                                       00030800
         CALL  RCCHECK,((4))  PASS RPL TO CHECK ROUTINE                 00030900
         LTR   R15,R15        CHECK VTAM MAJOR RC                       00031000
         BNZ   VTALE                                                    00031100
         LTR   R0,R0          CHECK LU6.2 RC                            00031200
         BZ    VTAL1                                                    00031300
*                                                                       00031400
VTALE    STM   R15,R0,VTALOCRC                                          00031500
         CALL  RCDISP,((4))                                             00031600
         LM    R15,R0,VTALOCRC                                          00031700
         B     VTALX                                                    00031800
*                                                                       00031900
*        BUILD RETURN VALUES FOR CALLER                                 00032000
*                                                                       00032100
VTAL1    EQU   *                                                        00032200
         USING IFGRPL,R4                                                00032300
         USING ISTRPL6X,R5                                              00032400
         L     R5,RPLAAREA                                              00032500
         MVC   0(4,R11),RPL6CNVD RETURN THE CONVID                      00032600
         DROP  R4                                                       00032700
         DROP  R5                                                       00032800
*                                                                       00032900
*        RESTORE REGISTERS AND EXIT PROGRAM                             00033000
*                                                                       00033100
VTALX    L     R11,RCPARM3                                              00033200
         ST    R15,0(R11)     RETURN PRIMARY RC                         00033300
         ST    R0,4(R11)      RETURN SECONDARY RC                       00033400
*                                                                       00033500
         L     R13,4(R13)                                               00033600
         L     R14,12(R13)                                              00033700
         LM    R1,R12,24(R13) RC = R15/R0                               00033800
         BR    R14                                                      00033900
VTALOCSV DS    18F                                                      00034000
VTALOCRC DS    2F                                                       00034100
RCPARM3  DS    F                                                        00034200
         LTORG                                                          00034300
         DROP  R3                                                       00034400
*                                                                       00034500
**************************************************************          00034600
VTSEND   CSECT                                                          00034700
**************************************************************          00034800
*                                                                       00034900
* VTSEND:                                                               00035000
*                                                                       00035100
* THIS CSECT PERFORMS VTAM SENDDATA MACRO                               00035200
*                                                                       00035300
* REGISTERS AT ENTRY:                                                   00035400
*    R13 = HSA                                                          00035500
*    R14 = RETURN ADDRESS                                               00035600
*    R15 = ENTRY ADDRESS                                                00035700
*    R1  = POINTER TO ADDRESS LIST                                      00035800
*          PARM1 = CONVID                                               00035900
*          PARM2 = DATA BUFFER ADDRESS                                  00036000
*          PARM3 = BUFFER LENGTH                                        00036100
*          PARM4 = RETURN CODE ADDR                                     00036200
*                                                                       00036300
*  RETURN VALUES:                                                       00036400
*    R15 = VTAM MAJOR/FEEDBACK2 RC                                      00036500
*    R0  = LU6.2 RC                                                     00036600
*                                                                       00036700
**************************************************************          00036800
*                                                                       00036900
*        ESTABLISH ADDRESSABILITY AND SETUP SAVEAREA LINK               00037000
*                                                                       00037100
         USING *,R3                                                     00037200
         STM   R14,R12,12(R13)                                          00037300
         LR    R3,R15                                                   00037400
         LA    R11,VTSENDSV                                             00037500
         ST    R11,8(R13)                                               00037600
         ST    R13,4(R11)                                               00037700
         LR    R13,R11                                                  00037800
*                                                                       00037900
* GET THE PARAMETERS                                                    00038000
*                                                                       00038100
         L     R4,0(R1)       CONVID ADDR                               00038200
         L     R5,4(R1)       BUFFER ADDR                               00038300
         L     R6,8(R1)       BUFFER LENGTH ADDR                        00038400
         LH    R7,0(R6)       PICK UP THE LENGTH VALUE                  00038500
         L     R8,12(R1)      RETURN CODE ADDR                          00038600
         ST    R8,RCPARM4                                               00038700
*                                                                       00038800
* GET THE RPL FOR THE PASSED CONVID                                     00038900
*                                                                       00039000
         CALL  GETRPL,((4))   PASS THE CONVID TO GETRPL ROUTINE         00039100
         LTR   R15,R15        TEST GOOD RC                              00039200
         BNZ   VTSX           NO - EXIT ROUTINE                         00039300
         LR    R4,R0          RPL ADDR IS RETURNED IN R0                00039400
*                                                                       00039500
* SEND THE DATA                                                         00039600
*                                                                       00039700
         APPCCMD CONTROL=SEND,                                         X00039800
               QUALIFY=DATA,                                           X00039900
               RPL=(4),                                                X00040000
               AREA=(5),                                               X00040100
               RECLEN=(7)                                               00040200
*                                                                       00040300
* CHECK THE RETURN CODE - PASS R15 RC BACK TO CALLER                    00040400
*                                                                       00040500
         CALL  RCCHECK,((4))  PASS RPL TO CHECK ROUTINE                 00040600
         LTR   R15,R15        CHECK VTAM MAJOR RC                       00040700
         BNZ   VTSE                                                     00040800
         LTR   R0,R0          CHECK LU6.2 RC                            00040900
         BZ    VTSX                                                     00041000
*                                                                       00041100
VTSE     STM   R15,R0,VTSENDRC                                          00041200
         CALL  RCDISP,((4))                                             00041300
         LM    R15,R0,VTSENDRC                                          00041400
*                                                                       00041500
*        RESTORE REGISTERS AND EXIT PROGRAM                             00041600
*                                                                       00041700
VTSX     L     R11,RCPARM4                                              00041800
         ST    R15,0(R11)     RETURN PRIMARY RC                         00041900
         ST    R0,4(R11)      RETURN SECONDARY RC                       00042000
*                                                                       00042100
         L     R13,4(R13)                                               00042200
         L     R14,12(R13)                                              00042300
         LM    R1,R12,24(R13) RC = R15/R0                               00042400
         BR    R14                                                      00042500
VTSENDSV DS    18F                                                      00042600
VTSENDRC DS    2F                                                       00042700
RCPARM4  DS    F                                                        00042800
         LTORG                                                          00042900
         DROP  R3                                                       00043000
*                                                                       00043100
**************************************************************          00043200
VTCONFD  CSECT                                                          00043300
**************************************************************          00043400
*                                                                       00043500
* VTCONFD:                                                              00043600
*                                                                       00043700
* THIS CSECT PERFORMS VTAM SEND CONFIRMED MACRO                         00043800
*                                                                       00043900
* REGISTERS AT ENTRY:                                                   00044000
*    R13 = HSA                                                          00044100
*    R14 = RETURN ADDRESS                                               00044200
*    R15 = ENTRY ADDRESS                                                00044300
*    R1  = POINTER TO ADDRESS LIST                                      00044400
*          PARM1 = CONVID                                               00044500
*          PARM2 = RETURN CODE ADDR                                     00044600
*                                                                       00044700
*  RETURN VALUES:                                                       00044800
*    R15 = VTAM MAJOR/FEEDBACK2 RC                                      00044900
*    R0  = LU6.2 RC                                                     00045000
*                                                                       00045100
**************************************************************          00045200
*                                                                       00045300
*        ESTABLISH ADDRESSABILITY AND SETUP SAVEAREA LINK               00045400
*                                                                       00045500
         USING *,R3                                                     00045600
         STM   R14,R12,12(R13)                                          00045700
         LR    R3,R15                                                   00045800
         LA    R11,VTCONFSV                                             00045900
         ST    R11,8(R13)                                               00046000
         ST    R13,4(R11)                                               00046100
         LR    R13,R11                                                  00046200
*                                                                       00046300
* GET THE PARAMETERS                                                    00046400
*                                                                       00046500
         L     R4,0(R1)       CONVID ADDR                               00046600
         L     R5,4(R1)       RETURN CODE ADDR                          00046700
         ST    R5,RCPARM5                                               00046800
*                                                                       00046900
* GET THE RPL FOR THE PASSED CONVID                                     00047000
*                                                                       00047100
         CALL  GETRPL,((4))   PASS THE CONVID TO GETRPL ROUTINE         00047200
         LTR   R15,R15        TEST GOOD RC                              00047300
         BNZ   VTCFX          NO - EXIT ROUTINE                         00047400
         LR    R4,R0          RPL ADDR IS RETURNED IN R0                00047500
*                                                                       00047600
* SEND THE CONFIRMED                                                    00047700
*                                                                       00047800
         APPCCMD CONTROL=SEND,                                         X00047900
               QUALIFY=CONFRMD,                                        X00048000
               RPL=(4)                                                  00048100
*                                                                       00048200
* CHECK THE RETURN CODE - PASS R15 RC BACK TO CALLER                    00048300
*                                                                       00048400
         CALL  RCCHECK,((4))  PASS RPL TO CHECK ROUTINE                 00048500
         LTR   R15,R15        CHECK VTAM MAJOR RC                       00048600
         BNZ   VTCFE                                                    00048700
         LTR   R0,R0          CHECK LU6.2 RC                            00048800
         BZ    VTCFX                                                    00048900
*                                                                       00049000
VTCFE    STM   R15,R0,VTCONFRC                                          00049100
         CALL  RCDISP,((4))                                             00049200
         LM    R15,R0,VTCONFRC                                          00049300
*                                                                       00049400
*        RESTORE REGISTERS AND EXIT PROGRAM                             00049500
*                                                                       00049600
VTCFX    L     R11,RCPARM5                                              00049700
         ST    R15,0(R11)     RETURN PRIMARY RC                         00049800
         ST    R0,4(R11)      RETURN SECONDARY RC                       00049900
*                                                                       00050000
         L     R13,4(R13)                                               00050100
         L     R14,12(R13)                                              00050200
         LM    R1,R12,24(R13) RC = R15/R0                               00050300
         BR    R14                                                      00050400
VTCONFSV DS    18F                                                      00050500
VTCONFRC DS    2F                                                       00050600
RCPARM5  DS    F                                                        00050700
         LTORG                                                          00050800
         DROP  R3                                                       00050900
*                                                                       00051000
**************************************************************          00051100
VTDALOC  CSECT                                                          00051200
**************************************************************          00051300
*                                                                       00051400
* VTDALOC:                                                              00051500
*                                                                       00051600
* THIS CSECT PERFORMS VTAM DEALLOCATE MACRO                             00051700
*                                                                       00051800
* REGISTERS AT ENTRY:                                                   00051900
*    R13 = HSA                                                          00052000
*    R14 = RETURN ADDRESS                                               00052100
*    R15 = ENTRY ADDRESS                                                00052200
*    R1  = POINTER TO ADDRESS LIST                                      00052300
*          PARM1 = CONVID                                               00052400
*          PARM2 = RETURN CODE ADDR                                     00052500
*                                                                       00052600
*  RETURN VALUES:                                                       00052700
*    R15 = VTAM MAJOR/FEEDBACK2 RC                                      00052800
*    R0  = LU6.2 RC                                                     00052900
*                                                                       00053000
**************************************************************          00053100
*                                                                       00053200
*        ESTABLISH ADDRESSABILITY AND SETUP SAVEAREA LINK               00053300
*                                                                       00053400
         USING *,R3                                                     00053500
         STM   R14,R12,12(R13)                                          00053600
         LR    R3,R15                                                   00053700
         LA    R11,VTDEALSV                                             00053800
         ST    R11,8(R13)                                               00053900
         ST    R13,4(R11)                                               00054000
         LR    R13,R11                                                  00054100
*                                                                       00054200
* GET THE PARAMETERS                                                    00054300
*                                                                       00054400
         L     R4,0(R1)       CONVID ADDR                               00054500
         L     R5,4(R1)       RETURN CODE ADDR                          00054600
         ST    R5,RCPARM6                                               00054700
*                                                                       00054800
* GET THE RPL FOR THE PASSED CONVID                                     00054900
*                                                                       00055000
         CALL  GETRPL,((4))   PASS THE CONVID TO GETRPL ROUTINE         00055100
         LTR   R15,R15        TEST GOOD RC                              00055200
         BNZ   VTDAX          NO - EXIT ROUTINE                         00055300
         LR    R4,R0          RPL ADDR IS RETURNED IN R0                00055400
*                                                                       00055500
* APPC DEALLOCATE                                                       00055600
*                                                                       00055700
         APPCCMD CONTROL=DEALLOC,                                      X00055800
               QUALIFY=CONFIRM,                                        X00055900
               RPL=(4),                                                X00056000
               OPTCD=SYN                                                00056100
*                                                                       00056200
* CHECK THE RETURN CODE - PASS R15 RC BACK TO CALLER                    00056300
*                                                                       00056400
         CALL  RCCHECK,((4))  PASS RPL TO CHECK ROUTINE                 00056500
         LTR   R15,R15        CHECK VTAM MAJOR RC                       00056600
         BNZ   VTDAE                                                    00056700
         LTR   R0,R0          CHECK LU6.2 RC                            00056800
         BZ    VTDAX                                                    00056900
*                                                                       00057000
VTDAE    STM   R15,R0,VTDEALRC                                          00057100
         CALL  RCDISP,((4))                                             00057200
         LM    R15,R0,VTDEALRC                                          00057300
*                                                                       00057400
*        RESTORE REGISTERS AND EXIT PROGRAM                             00057500
*                                                                       00057600
VTDAX    L     R11,RCPARM6                                              00057700
         ST    R15,0(R11)     RETURN PRIMARY RC                         00057800
         ST    R0,4(R11)      RETURN SECONDARY RC                       00057900
*                                                                       00058000
         L     R13,4(R13)                                               00058100
         L     R14,12(R13)                                              00058200
         LM    R1,R12,24(R13) RC = R15/R0                               00058300
         BR    R14                                                      00058400
VTDEALSV DS    18F                                                      00058500
VTDEALRC DS    2F                                                       00058600
RCPARM6  DS    F                                                        00058700
         LTORG                                                          00058800
         DROP  R3                                                       00058900
*                                                                       00059000
**************************************************************          00059100
VTRCV5   CSECT                                                          00059200
**************************************************************          00059300
*                                                                       00059400
* VTRCV5:                                                               00059500
*                                                                       00059600
* THIS CSECT PERFORMS VTAM RECEIVE FMH5 MACRO                           00059700
*                                                                       00059800
* REGISTERS AT ENTRY:                                                   00059900
*    R13 = HSA                                                          00060000
*    R14 = RETURN ADDRESS                                               00060100
*    R15 = ENTRY ADDRESS                                                00060200
*    R1  = POINTER TO ADDRESS LIST                                      00060300
*          PARM1 = FMH5 BUFFER ADDRESS                                  00060400
*          PARM2 = BUFFER LENGTH                                        00060500
*          PARM3 = RETURN CONVID ADDRESS                                00060600
*          PARM4 = RETURN LUNAME ADDRESS                                00060700
*          PARM5 = RETURN CODE ADDR                                     00060800
*                                                                       00060900
*  RETURN VALUES:                                                       00061000
*    R15 = VTAM MAJOR/FEEDBACK2 RC                                      00061100
*    R0  = LU6.2 RC                                                     00061200
*                                                                       00061300
**************************************************************          00061400
*                                                                       00061500
*        ESTABLISH ADDRESSABILITY AND SETUP SAVEAREA LINK               00061600
*                                                                       00061700
         USING *,R3                                                     00061800
         STM   R14,R12,12(R13)                                          00061900
         LR    R3,R15                                                   00062000
         LA    R11,VTRCV5SV                                             00062100
         ST    R11,8(R13)                                               00062200
         ST    R13,4(R11)                                               00062300
         LR    R13,R11                                                  00062400
*                                                                       00062500
* GET THE PARAMETERS                                                    00062600
*                                                                       00062700
         L     R5,0(R1)       BUFFER ADDR                               00062800
         L     R6,4(R1)       BUFFER LENGTH ADDR                        00062900
         LH    R7,0(R6)       PICK UP THE LENGTH VALUE                  00063000
         L     R8,8(R1)       RETURN CONVID ADDR                        00063100
         L     R9,12(R1)      RETURN LUNAME ADDR                        00063200
         L     R10,16(R1)     RETURN CODE ADDR                          00063300
         ST    R10,RCPARM7                                              00063400
*                                                                       00063500
* GET AN RPL FOR THE NEW CONVERSATION                                   00063600
*                                                                       00063700
         CALL  GETRPL         GET A FREE RPL                            00063800
         LTR   R15,R15        TEST GOOD RC                              00063900
         BNZ   VTR5X          NO - EXIT ROUTINE                         00064000
         LR    R4,R0          RPL ADDR IS RETURNED IN R0                00064100
         L     R11,=F'256000' INITIALIZE MAX LOOP COUNT                 00064200
*                                                                       00064300
* RECEIVE THE FMH5 ATTACH HEADER                                        00064400
*                                                                       00064500
VTR51    APPCCMD CONTROL=RCVFMH5,                                      X00064600
               CONMODE=CS,                                             X00064700
               OPTCD=SYN,                                              X00064800
               RPL=(4),                                                X00064900
               AREA=(5),                                               X00065000
               AREALEN=(7)                                              00065100
*                                                                       00065200
* CHECK THE RETURN CODE - PASS R15/R0 RC BACK TO CALLER                 00065300
*                                                                       00065400
         CALL  RCCHECK,((4))  CHECK RETURN CODES - PASS RPL             00065500
         LTR   R15,R15        TEST VTAM MAJOR RC                        00065600
         BNZ   VTR52                                                    00065700
*                                                                       00065800
         LTR   R0,R0          TEST LU62 RC                              00065900
         BZ    VTR53                                                    00066000
         C     R0,=XL4'00600000' CHECK IF FMH5 RETURNED                 00066100
         BNE   VTR52          NO - TRY AGAIN                            00066200
*                                                                       00066300
         BCT   R11,VTR51      TRY AGAIN UNTIL MAX RETRIES UP            00066400
*                                                                       00066500
*        ERROR                                                          00066600
*                                                                       00066700
VTR52    STM   R15,R0,VTRCV5RC                                          00066800
         CALL  RCDISP,((4))                                             00066900
         LM    R15,R0,VTRCV5RC                                          00067000
*                                                                       00067100
*        BUILD RETURN VALUES FOR CALLER                                 00067200
*                                                                       00067300
VTR53    EQU   *                                                        00067400
         USING IFGRPL,R4                                                00067500
         USING ISTRPL6X,R5                                              00067600
         L     R5,RPLAAREA                                              00067700
         MVC   0(4,R8),RPL6CNVD RETURN THE CONVID                       00067800
         MVC   0(8,R9),RPL6LU   AND THE LUNAME                          00067900
         DROP  R4                                                       00068000
         DROP  R5                                                       00068100
*                                                                       00068200
*        RESTORE REGISTERS AND EXIT PROGRAM                             00068300
*                                                                       00068400
VTR5X    L     R11,RCPARM7                                              00068500
         ST    R15,0(R11)     RETURN PRIMARY RC                         00068600
         ST    R0,4(R11)      RETURN SECONDARY RC                       00068700
*                                                                       00068800
         L     R13,4(R13)                                               00068900
         L     R14,12(R13)                                              00069000
         LM    R1,R12,24(R13) RC = R15/R0                               00069100
         BR    R14                                                      00069200
VTRCV5SV DS    18F                                                      00069300
VTRCV5RC DS    2F                                                       00069400
RCPARM7  DS    F                                                        00069500
         LTORG                                                          00069600
         DROP  R3                                                       00069700
*                                                                       00069800
**************************************************************          00069900
VTRCV    CSECT                                                          00070000
**************************************************************          00070100
*                                                                       00070200
* VTRCV:                                                                00070300
*                                                                       00070400
* THIS CSECT PERFORMS VTAM RECEIVE MACRO                                00070500
*                                                                       00070600
* REGISTERS AT ENTRY:                                                   00070700
*    R13 = HSA                                                          00070800
*    R14 = RETURN ADDRESS                                               00070900
*    R15 = ENTRY ADDRESS                                                00071000
*    R1  = POINTER TO ADDRESS LIST                                      00071100
*          PARM1 = CONVID                                               00071200
*          PARM2 = DATA BUFFER ADDRESS                                  00071300
*          PARM3 = BUFFER LENGTH                                        00071400
*          PARM4 = RETURN RECEIVE LENGTH                                00071500
*          PARM5 = RETURN WHAT RECEIVED INDICATOR                       00071600
*          PARM6 = RETURN CODE ADDR                                     00071700
*                                                                       00071800
*  RETURN VALUES:                                                       00071900
*    R15 = VTAM MAJOR/FEEDBACK2 RC                                      00072000
*    R0  = LU6.2 RC                                                     00072100
*                                                                       00072200
**************************************************************          00072300
*                                                                       00072400
*        ESTABLISH ADDRESSABILITY AND SETUP SAVEAREA LINK               00072500
*                                                                       00072600
         USING *,R3                                                     00072700
         STM   R14,R12,12(R13)                                          00072800
         LR    R3,R15                                                   00072900
         LA    R11,VTRCVSV                                              00073000
         ST    R11,8(R13)                                               00073100
         ST    R13,4(R11)                                               00073200
         LR    R13,R11                                                  00073300
*                                                                       00073400
* GET THE PARAMETERS                                                    00073500
*                                                                       00073600
         L     R4,0(R1)       CONVID ADDR                               00073700
         L     R5,4(R1)       BUFFER ADDR                               00073800
         L     R6,8(R1)       BUFFER LENGTH ADDR                        00073900
         LH    R7,0(R6)       PICK UP THE LENGTH VALUE                  00074000
* RETURN VALUE PARAMETER ADDRESSES                                      00074100
         L     R8,12(R1)      RETURN LENGTH ADDR                        00074200
         L     R9,16(R1)      WHATRCV FLAG ADDR                         00074300
         L     R10,20(R1)     RETURN CODE ADDR                          00074400
         ST    R10,RCPARM8                                              00074500
*                                                                       00074600
* GET THE RPL FOR THE PASSED CONVID                                     00074700
*                                                                       00074800
         CALL  GETRPL,((4))   PASS THE CONVID TO GETRPL ROUTINE         00074900
         LTR   R15,R15        TEST GOOD RC                              00075000
         BNZ   VTRX           NO - EXIT ROUTINE                         00075100
         LR    R4,R0          RPL ADDR IS RETURNED IN R0                00075200
*                                                                       00075300
* RECEIVE THE DATA                                                      00075400
*                                                                       00075500
         APPCCMD CONTROL=RECEIVE,                                      X00075600
               QUALIFY=SPEC,                                           X00075700
               CONMODE=SAME,                                           X00075800
               FILL=LL,                                                X00075900
               RPL=(4),                                                X00076000
               AREA=(5),                                               X00076100
               AREALEN=(7)                                              00076200
*                                                                       00076300
* CHECK THE RETURN CODE - PASS R15 RC BACK TO CALLER                    00076400
*                                                                       00076500
         CALL  RCCHECK,((4))  PASS RPL TO CHECK ROUTINE                 00076600
         LTR   R15,R15        CHECK VTAM MAJOR RC                       00076700
         BNZ   VTRE                                                     00076800
         LTR   R0,R0          CHECK LU6.2 RC                            00076900
         BZ    VTR1                                                     00077000
*                                                                       00077100
VTRE     STM   R15,R0,VTRCVRC                                           00077200
         CALL  RCDISP,((4))                                             00077300
         LM    R15,R0,VTRCVRC                                           00077400
*                                                                       00077500
*        BUILD RETURN VALUES FOR CALLER                                 00077600
*                                                                       00077700
VTR1     EQU   *                                                        00077800
         USING IFGRPL,R4                                                00077900
         USING ISTRPL6X,R5                                              00078000
         L     R5,RPLAAREA                                              00078100
         L     R11,RPLRLEN    GET RECEIVED LENGTH  (FULLWORD)           00078200
         STH   R11,0(R8)      AND RETURN TO CALLER (HALFWORD)           00078300
         IC    R11,RPL6WHAT   GET WHAT RECEIVED INDICATOR               00078400
         STC   R11,0(R9)      AND RETURN TO CALLER                      00078500
*                                                                       00078600
*        RESTORE REGISTERS AND EXIT PROGRAM                             00078700
*                                                                       00078800
VTRX     L     R11,RCPARM8                                              00078900
         ST    R15,0(R11)     RETURN PRIMARY RC                         00079000
         ST    R0,4(R11)      RETURN SECONDARY RC                       00079100
*                                                                       00079200
         L     R13,4(R13)                                               00079300
         L     R14,12(R13)                                              00079400
         LM    R1,R12,24(R13) RC = R15/R0                               00079500
         BR    R14                                                      00079600
VTRCVSV  DS    18F                                                      00079700
VTRCVRC  DS    2F                                                       00079800
RCPARM8  DS    F                                                        00079900
         LTORG                                                          00080000
         DROP  R3                                                       00080100
*                                                                       00080200
* DSECTS                                                                00080300
*                                                                       00080400
         IFGACB AM=VTAM                                                 00080500
         IFGRPL AM=VTAM                                                 00080600
         ISTFM5                                                         00080700
         ISTSLCNS                                                       00080800
         END                                                            00080900
* -------- End of File ------------------  
